---
name: Feature implementation
about: Set scope of work for a new feature implementation
title: '[FEATURE]'
labels: enhancement
assignees: ''

---

### Feature
A clear and concise description of the feature to be implemented and why.

### Proposal
A plan or brief overview of how the feature will be implemented.

### Testing
A detailed description of how this feature will be tested.
* What are the core aspects of the feature that need testing?
* Outline the test cases and for each specify:
    * The purpose of the test.
    * The inputs.
    * The expected output.

### Benchmarking (Optional)
Describe how and why this feature needs to be benchmarked with regards to:
* Performance in metric(s)...
* Speed
* Scale

### Definition of done
A precise outline for the feature to be considered fully implemented, i.e. done/complete.

### Mandatory checklist before making a PR
* [ ] The success criteria laid down in “Definition of done” are met.
* [ ] Code is documented - docstrings for methods and classes, static types for arguments.
* [ ] Code is tested - unit, integration and/or functional tests are added.
* [ ] Documentation is updated - README, CONTRIBUTING, or other documentation.
* [ ] All functional tests are green.
* [ ] Link experiment/benchmarking after implementation (optional).

<!-- Base checklist. Don’t hesitate to adapt it to your use-case. -->

### Links / references / screenshots
<!-- For ex: link to CI job, experiment runs, etc. -->
