---
name: Planned test
about: Outline the structure for a planned test, this could be broader system/integration tests or for tests for existing code.
title: '[TEST]'
labels: test
assignees: ''

---

### What do you want to test?
A brief description of the feature to be tested (with a link to the feature issue, if applicable).

### Outline of test structure
* What type of test(s)? i.e. unit, integration, functional.
* Describe the test cases and for each:
    * What will be the inputs?
    * What is the expected output?

### Definition of done
A precise description for the test(s) to be considered fully implemented, i.e. done/complete.

### Mandatory checklist before making a PR
* [ ] The success criteria laid down in “Definition of done” are met.
* [ ] Test code is documented - docstrings for methods and classes, static types for arguments.
* [ ] Documentation is updated - README, CONTRIBUTING, or other documentation.

<!-- Base checklist. Don’t hesitate to adapt it to your use-case. -->

### Links / references / screenshots
